% does GMM estimate. set up as function so you can do lots of variations
 function [lambdasfin,S,d,lam0,lam1,mu,phi] = dogmm(lambdas,graph_gmm_objective,graph_label,phistar,mustar,delta0,delta1,qr,A,B,X,V,rx,wts)

    disp('initial lambdas and  objective')
    disp([lambdas'  gmmobj(lambdas,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx,wts)]);
    disp('initial lambdas');
    [lambdasfin, gvalue, exitflag, output] =...
        fminunc(@(lambdas) gmmobj(lambdas,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx,wts),lambdas); 
    disp('First stage: lambdas, objective')
    disp([lambdasfin' gvalue]);
    
    % standard errors, look at S matrix before proceeding
    % a = d'W so 1/T (ad)^-1 aS a' (ad)^-1 = (d'Wd)^-1* d'WSWd (d'Wd)^-1
    
    S = findS(lambdasfin,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx);
    d = find_d(lambdasfin,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx,wts);
    T = size(X,1);
    
    % look at moments
    
    if rank(d'*wts)<2;
        fprintf ('rank d''W = %f3.1 < 2. Gmm is setting d=0, not gt=0, lambdas are unidentified, standard errors are infinite.\n',rank(d'*wts));
        disp('moments after minimization gT x 100'); 
        newg = findg(lambdasfin,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx);
        disp(100*newg');
    else;
        covlambda = 1/(T/12)*inv(d'*wts*d)*d'*wts*S*wts*d*inv(d'*wts*d); 
        stderrs = diag(covlambda).^0.5; 
        disp('standard errors of lambda'); 
        disp(stderrs'); 
        disp('moments after minimization gT x 100'); 
        newg = findg(lambdasfin,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx);
        disp(100*newg');
        covgt = 1/(T/12)*(eye(9)-d*inv(d'*wts*d)*d'*wts)*S*(eye(9)-d*inv(d'*wts*d)*d'*wts)';
        disp('standard error of moments cov(gT)')
        disp(100*diag(covgt)'.^0.5);
    end
    disp('standard error of moments before estimation -- S matrix diagonals'); 
    disp(100/(T/12)*diag(S)'.^0.5);
    
    % look at model predictions    
    lam0f = lambdasfin(1); 
    lam1f = lambdasfin(2); 
    lam0 = [ 0 lam0f 0 0]'; 
    lam1 = [ [ 0 lam1f 0 0]' zeros(4,3)]; % pad out to usual matrix size
    phi = phistar + V*lam1;
    mu = mustar + V*lam0; 
    BVB = zeros(14,1);
    for i = 1:14; 
        BVB(i) = B(i,:)*V*B(i,:)';% BVB(1) corresponds to rx(2)
    end;

    predcon = -1/2*qr'*BVB + qr'*B(1:14,:)*V(:,2)*lam0f; 
    predslope = qr'*B(1:14,:)*V(:,2)*lam1f; 
    predmeanx =  inv(eye(4)-phi)*mu; 
    fprintf('predicted const, slope (0,1?)  %8.3f %8.3f \n',predcon,predslope); 
    fprintf('predicted mean of factors, y1  %8.3f %8.3f %8.3f %8.3f %8.3f\n',predmeanx,100*(delta0+delta1'*predmeanx)); 
    fprintf('  sample  mean of factors, y1  %8.3f %8.3f %8.3f %8.3f %8.3f\n',mean(X),100*(delta0+mean(X)*delta1)); 

    disp('eigenvalues of phi matrix first actual then abs')
    disp(eig(phi)');
    disp(abs(eig(phi))');
    
    if graph_gmm_objective
        lam0vals = (-8:.5:8)';
        lam1vals = (-120:.5:-15)';
        clear answer;
        for i = 1:size(lam0vals,1); 
            for j = 1:size(lam1vals,1);
                answer(i,j) = gmmobj([lam0vals(i) lam1vals(j)]',phistar, mustar,delta0, delta1,qr,A,B,X,V,rx,wts);
            end;
        end;
    
       % figure
       % surf(lam0vals,lam1vals,log(answer'));
       % xlabel('\lambda_0');
       % ylabel('\lambda_1'); 
    
       lowest = min(min(log(answer)));
       starts = floor(10*lowest)/10;
       ends = floor(starts + 3); 
        figure
        [C,h] = contour(lam0vals,lam1vals,log(answer'), [lowest (starts:0.1:ends) ends+(1:3)]);
        xlabel('\lambda_0');
        ylabel('\lambda_1');
        set (h,'ShowText','on')
        title(['Objective - ' graph_label])
    end
    
    
    
    