%dointro -- introductory data analysis. 
% called by fed_yc_regressions

% THIS produces a lot of unused junk. Eventually go through and see which
% pictures are important enough to keep as documentation (and put a title
% on them so you know what they are) and which are junk. 

% --------------------------
% graph of two recent episodes
% -----------------------

figure; 
subplot(2,1,1)
plot(plotdate(indx1:indx2),100*f(indx1:indx2,[10 5 1]),'LineWidth',2);
hold on
plot(plotdate(indx1:indx2),ff(indx1:indx2),'-k','LineWidth',2); 
plot(plotdate(indx1:indx2),100*f(indx1:indx2,[ 2 3 4 15 ])); 
axis([1990 1996.4 2 10]);
legend('10','5','1','ff',3); 

subplot(2,1,2)
plot(plotdate(indx3:T),100*f(indx3:T,[10 5 1]),'LineWidth',2);
hold on
plot(plotdate(indx3:T),ff(indx3:T),'-k','LineWidth',2); 
plot(plotdate(indx3:T),100*f(indx3:T,[ 2 3 4 15 ])); 
legend('10','5','1','ff',3);
plot([1;1]*plotdate(dates)',[0 ;10]*ones(1,size(dates,1)),'-k','LineWidth',2)
axis([2000 2006.4 0 8])

print -depsc2 forwards_hist_recent.eps

% plot comparing two datasets
figure
plot(plotdate(end-27:end),100*f_fb(end-27:end,:));
hold on
plot(plotdate(end-27:end),100*f(end-27:end,:))
axis([2003.5 2006.5 0 7])
text(2003.9*ones(11,1),100*f(end-27,[1:10 15]),...
    [' 1'; ' 2'; ' 3'; ' 4'; ' 5'; ' 6'; ' 7'; ' 8'; ' 9'; '10'; '15'],'HorizontalAlignment','Right'); 

% ------------------
% mean y(1) and standard error
% -------------------------

disp('monthly data')
disp('mean y(1), sd y(1), ay, std error conf int') 
b = [ones(T-1,1) y(1:T-1,1)]\y(2:T,1); 
b = b(2); 
stderr = ((1+b)/(1-b))^0.5*std(y(:,1))/T^0.5;
disp([100*mean(y(:,1)) 100*std(y(:,1)) b 100*stderr]);

ya = y(1:12:T,1); 
Ta = size(ya,1);
disp('annual data') 
b = [ones(Ta-1,1) y(1:Ta-1,1)]\y(2:Ta,1); 
b = b(2); 
stderr = ((1+b)/(1-b))^0.5*std(ya)/Ta^0.5;
disp([100*mean(ya) 100*std(ya) b 100*stderr 100*(mean(ya)-2*stderr) 100*(mean(ya)+2*stderr)]);

% ------------------------
% VAR forecasts
% ------------------------

% ------------------------------------------------           
% case 1 pure VAR in levels. Forwards on forwards, though it should make no difference whether yields forwards or prices. 
% -------------------------------------------------

    rhs = f_ma_fb(1:T-1*12,:) - ones(T-12,1)*mean( f_ma_fb(1:T-1*12,:)); 
    rhsbig =  f_ma_fb - ones(T,1)*mean(f_ma_fb);          % extends right hand variable to  present 
lhs = f_fb(12+1:T,:)- ones(T-12,1)*mean(f_fb(12+1:T,:));
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);  % std errors -- get lags right.

% now find implied coefficients of y^(1)_t+j on y_t

A = b1'; % Standard VAR transition matrix f_t+1 = A f_t 
b1a(:,1) = A(1,:)'; % coeffs of y^(1)_t+1 on f_t. Create the analog to the above b1 
A2 = A; 

maxmat = 15; 
for i = 2:maxmat; % with a VAR you can go out past current yield curve
    A2 = A2*A; 
    b1a(:,i) = A2(1,:)'; % implied coeffs of y^(1) t+j on  f_t
end; 
    fit_VAR = rhsbig*b1a + ones(T,maxmat)*mean(f_ma(:,1)); % This is expected y(1) _ t+j based on forward (equivalently yield) 

fEH_VAR =  [ y(:,1) fit_VAR ] ;

% ------------------------------
% direct estimate of y_t+k-y_t on f_t. 
% this is used for standard errors even if dropped from the plot
% -------------------------------

fEH = [ y(:,1) ] ;
fEH_se = [ zeros(T,1) ];
for i = 1:10; % horizon 
        rhs = [ones(T-12*i,1) f_ma_fb(1:T-i*12,2:end)-f_ma_fb(1:T-i*12,1)*ones(1,4)]; 
        rhsbig =  [ones(T,1) f_ma_fb(:,2:end)-f_ma_fb(:,1)*ones(1,4) ]; % extends right hand variable to  present 
    lhs = [y(12*i+1:end,1)-y(1:T-12*i,1)];
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12*i,2);  % JC special std errors -- HH but simplified. 

    fit =  rhsbig*b1+y(:,1); % This is expected y(1)_t+j-y(1)_t based on forward (equivalently yield) 

    for t = 1:T;
        sefit(t) = rhsbig(t,:)*v*rhsbig(t,:)'; 
    end;
    if any(any(sefit<0))
        disp('warning: some standard errors less than zero -- use NW not HH'); 
    end; 
    sefit = (abs(sefit)).^0.5    ;
   
    fEH = [ fEH fit] ;
    fEH_se = [ fEH_se sefit' ];
end; 

% ------------------
% case 2 differences and spreads, i.e. no level. Find implied level VAR. 
% --------------------

rhs = f_ma_fb(1:T-1*12,2:end)-y_fb(1:T-1*12,1)*ones(1,4); % rhs is forward - y(1)  
rhs = rhs - ones(T-1*12,1)*mean(rhs);
lhs = f_fb(12+1:T,:)-f_fb(1:T-1*12,1)*ones(1,5); % lhs is forward(n)_t+1 - y^(1)_t -- standard VAR in spreads
lhs = lhs - ones(T-1*12,1)*mean(lhs);

[b1diff,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);  

% now find implied coefficients of y^(1)_t+j on f_t

b1 = [ones(1,5)-sum(b1diff);b1diff]; % this is the implied coeffs, imposing zero on lagged level
                                     % x_t+1 - y(1)_t = b*[f(n)_t - y(1)_t]
                                     % x_t+1 = [1 - b]*y(1)_t + b*f(n)_t 

% rest is copied from above
A = b1'; % Standard VAR transition matrix y_t+1 = A y_t 
b1a(:,1) = A(1,:)'; % coeffs of y^(1)_t+1 on f_t. Create the analog to the above b1 
A2 = A; 
for i = 2:maxmat; % with a VAR you can go out past current yield curve
    A2 = A2*A; 
    b1a(:,i) = A2(1,:)';
end; 

    rhsbig =  [ y(:,1) f_ma_fb(:, 2:end)] - ones(T,1)*mean([ y_fb(:,1) f_ma_fb(:, 2:end)]);        % extends right hand variable to  present 

fit_VAR_diff = rhsbig*b1a + ones(T,maxmat)*mean(y_fb(:,1)); % This is expected y(1) _ t+j based on forward (equivalently yield) 

fEH_VAR_diff =  [ y_fb(:,1) fit_VAR_diff ] ;


% ---------------
% 4 panel plot 
% -------------

figure; 

for i = 1:3; 
    subplot(2,2,i)

    plot((1:10)',100*f(dates(i),1:10)','-vk','LineWidth',2,'MarkerSize',2) % forward rate on this date
    hold on
	plot((1:5)',100*f_fb(dates(i),1:5)','-vm','LineWidth',2,'MarkerSize',2) % forward rate on this date
	
    if i == 3; % only here because it steps on the other ones. 
		text(10.2,100*f(dates(i),10),'Fwds','Color','k'); 
    end;
    hold on; 
    plot((1:10)',100*fEH_VAR(dates(i),1:10)','-or','LineWidth',2,'MarkerSize',2);
    text(10.2,100*fEH_VAR(dates(i),10),'VAR','Color','r');
    
    plot((1:10)',100*fEH_VAR_diff(dates(i),1:10)','-sb','LineWidth',2,'MarkerSize',2);
    text(10.2,100*fEH_VAR_diff(dates(i),10),'VAR, diff. ','Color','b');

%    plot((1:10)',100*fEH(dates(i),1:10)','-om','LineWidth',2,'MarkerSize',2); -- direct, not shown. 
%    text(11,100*fEH(dates(i),10),'Direct ','Color','r');
    errorbar([2 5 9]',100*fEH_VAR_diff(dates(i),[2 5 9])',100*fEH_se(dates(i),[2 5 9])','.b');  % uses direct errors 
    
    
    %set(gca,'Xtick',[ 0 1 2 3 4 5 6 7]); 
    xlabel('Maturity'); 
    ylabel('Rate'); 
    
    year = floor(qdate/10000);
    year = 1900*(year>50)+2000*(year<50)+year; 
    mo = qdate-10000*floor(qdate/10000);
    mo = floor(mo/100); 
    datestring = [num2str(year(dates(i)),'%4.0f') ' ' num2str(mo(dates(i)),'%4.0f')];
    %text(1.1,4.5,datestring);
    title(datestring);
    axis([0 14 1 8]);
end; 


subplot(2,2,4); 
plot(plotdate(indx3:T),100*f(indx3:T,10),'-k','LineWidth',2);
text(plotdate(T)+1/12,100*f(T,10),'10 y fwd','Color','k'); 
hold on
plot(plotdate(indx3:T),100*fEH_VAR(indx3:T,10),'-r','LineWidth',2);
text(plotdate(T)+1/12,100*fEH_VAR(T,10),'VAR','Color','r'); 
plot(plotdate(indx3:T),100*fEH_VAR_diff(indx3:T,10),'-b','LineWidth',2);
text(plotdate(T)+1/12,100*fEH_VAR_diff(T,10),'VAR, diff','Color','b'); 

%plot(plotdate(indx3:T),ff(indx3:T),'-k','LineWidth',2); 
plot([1;1]*plotdate(dates)',[0 ;10]*ones(1,size(dates,1)),'-k','LineWidth',2)
axis([2000 2008 1 8])

print -depsc2 curves_and_regressions.eps


% ----------------------------------------
% plot forecast of spot rates at each date
% ----------------------------------------

figure; 
subplot(2,1,1)
plot(plotdate,100*fEH_VAR); 
%legend(num2str((1:maxmat)','%4.0f'));
axis([1971 2007 0 inf]) ;
title('VAR in levels'); 

subplot(2,1,2)
plot(plotdate,100*fEH_VAR_diff); 
%legend(num2str((1:maxmat)','%4.0f'));
axis([1971 2007 0 inf]) ;
title('VAR in differences'); 

print -depsc2 forecasts.eps

% ------------
% return forecasts 
% -------------

disp('**** Return forecasts in GSW data *****'); 

% 1, 3, 5, 

fcstmats = [1 3 5 ]';
rhs = [ones(T-12*1,1) f(1:T-12*1,fcstmats)];
lhs = rx(1*12+1:T,1:14);
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting each maturity rx on forwards of maturity') 
disp(fcstmats'); 
disp(R2'); 
figure; 
plot(fcstmats,b1(2:end,:),'-v')
title('returns on f1,3,5') 

lhs = mean(rx(1*12+1:T,1:14)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting avg return (across maturity) on these forwards') 
disp(R2)

% 1 - 5 

fcstmats = [1 2 3 4 5 ]';
rhs = [ones(T-12*1,1) f(1:T-12*1,fcstmats)];
lhs = rx(1*12+1:T,1:14);
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting each maturity rx on forwards of maturity') 
disp(fcstmats'); 
disp(R2'); 
figure; 
plot(fcstmats,b1(2:end,:),'-v')
title(' returns on f1-f5') 

lhs = mean(rx(1*12+1:T,1:14)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting avg return (across maturity) on these forwards') 
disp(R2)

% 1 - 15 

rhs = [ones(T-12*1,1) f(1:T-12*1,:)];
lhs = mean(rx(1*12+1:T,1:14)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2, average return (across maturity) on all forwards'); 
disp(R2)
figure; 
plot(b1(2:end,:),'-v')
title('all forwards, average (across mat) ret.') 

% Moving average RHS 

   
    rhs = [ones(T-12*1,1) f_ma(1:T-12*1,fcstmats)];
    lhs = rx(1*12+1:T,1:14);
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2 of forecasting each maturity rx on MA forwards of maturity') 
    disp(fcstmats'); 
    disp(R2');  

    lhs = mean(rx(1*12+1:T,:)')';
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2 of forecasting avg return (across maturity) on these MA forwards') 
    disp(R2)
    
    rhs = [ones(T-12*1,1) f_ma(1:T-12*1,:)];
    lhs = mean(rx(1*12+1:T,:)')';
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2, average return on all MA of forwards'); 
    disp(R2)
    figure; 
    plot(b1(2:end,:),'-v')
    title('all MA forwards, average (across mat) ret.') 

% ----------
% GSW returns on FB forwards 
% ------------

disp('**** running fed returns on fb forwards') 

% 1 2 3 4 5 

fcstmats = [1 2 3 4 5 ]';
rhs = [ones(T-12*1,1) f_fb(1:T-12*1,fcstmats)];
lhs = rx(1*12+1:T,1:14);
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);

disp('R2 of forecasting fed  rx from FB forwards of maturity') 
disp(fcstmats'); 
disp(R2'); 

figure; 
plot(fcstmats,b1(2:end,:),'-v')
title('fed returns, all fb forwards') 

lhs = mean(rx(1*12+1:T,1:14)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting avg fed return (across maturity) on these FB forwards') 
disp(R2)

% 1,3, 5, 

fcstmats = [1 3 5 ]';
rhs = [ones(T-12*1,1) f_fb(1:T-12*1,fcstmats)];
lhs = rx(1*12+1:T,1:14);
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);

disp('R2 of forecasting fed  rx from FB forwards of maturity') 
disp(fcstmats'); 
disp(R2'); 

lhs = mean(rx(1*12+1:T,1:14)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2, average Fed return (across maturity) on these forwards'); 
disp(R2)

figure; 
plot(fcstmats,b1(2:end,:),'-v')
title(' fb forwards 1-3, average (across mat) fed ret.') 

    
    rhs = [ones(T-12*1,1) f_ma_fb(1:T-12*1,fcstmats)];
    lhs = rx(1*12+1:T,1:14);
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);

    disp('R2 of forecasting each maturity rx on MA forwards of maturity') 
    disp(fcstmats'); 
    disp(R2');  

    lhs = mean(rx(1*12+1:T,:)')';
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2 of forecasting avg return (across maturity) on these MA forwards') 
    disp(R2)

    
    rhs = [ones(T-12*1,1) f_ma_fb(1:T-12*1,:)];
    lhs = mean(rx(1*12+1:T,:)')';
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2, average return on all MA of forwards'); 
    disp(R2)
    figure; 
    plot(b1(2:end,:),'-v')
    title('all MA forwards, average (across mat) ret.') 

% ----------
% FB returns on FB forwards 
% ------------

disp('**** running FB returns on fb forwards') 

% 1 2 3 4 5 

fcstmats = [1 2 3 4 5 ]';
disp(fcstmats'); 
rhs = [ones(T-12*1,1) f_fb(1:T-12*1,fcstmats)];
lhs = mean(rx_fb(1*12+1:T,:)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting avg FB return (across maturity) on these FB forwards') 
disp(R2)

% 1,3, 5, 

fcstmats = [1 3 5 ]';
disp(fcstmats'); 
rhs = [ones(T-12*1,1) f_fb(1:T-12*1,fcstmats)];
lhs = mean(rx_fb(1*12+1:T,:)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2, average FB return (across maturity) on these forwards'); 
disp(R2)

  
    rhs = [ones(T-12*1,1) f_ma_fb(1:T-12*1,:)];
    lhs = mean(rx_fb(1*12+1:T,:)')';
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2, average return on all MA of forwards'); 
    disp(R2)
    


% -------------------------------------
% both GSW and FB returns on FB forwards, no levels
% -------------------------------------


disp('**** GSW returns osn FB forwards with no level effect') 


fcstmats = [2 3 4 5 ]';
disp(fcstmats'); 
rhs = [ones(T-12*1,1) f_fb(1:T-12*1,fcstmats)-f_fb(1:T-12*1,1)*ones(1,size(fcstmats,1))];
lhs = mean(rx(1*12+1:T,:)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2 of forecasting avg FB return (across maturity) on these FB forward SPREADS') 
disp(R2)

% 1,3, 5, 

fcstmats = [3 5 ]';
disp(fcstmats'); 
rhs = [ones(T-12*1,1) f_fb(1:T-12*1,fcstmats)-f_fb(1:T-12*1,1)*ones(1,size(fcstmats,1))];
lhs = mean(rx(1*12+1:T,:)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('R2, average FB return (across maturity) on these forwards'); 
disp(R2)

  
    rhs = [ones(T-12*1,1) f_ma_fb(1:T-12*1,2:end)-f_ma_fb(1:T-12*1,1)*ones(1,size(f_ma_fb,2)-1)];
    lhs = mean(rx(1*12+1:T,:)')';
    [b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
    disp('R2, average return on all MA of forwards'); 
    disp(R2)
    
 
% ------------------
% 3 factor VAR
% ---------------

% part 1: basic eigenvalue decomposition for comparison

[Q,L] = eig(cov(y));
Ld = diag(L);
if ~min(Ld == sort(Ld));
    disp('**************ERROR eigenvalues are in wrong order'); 
end;

fprintf(' y s.d of factors        %8.2f %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-4:end).^0.5);
fprintf('   percent of variance   %8.2f %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-4:end)/sum(Ld));

figure
plot(Q(:,end),'-vb','LineWidth',2);
hold on
plot(Q(:,end-1),'-or','LineWidth',2);
plot(Q(:,end-2),'-sg','LineWidth',2);
plot(Q(:,end-3),'--c');
plot(Q(:,end-4),'--m');
plot((1:maxmat)',0*(1:maxmat)','-k')
legend(['level, \sigma = ' num2str(100*Ld(end)^0.5,'%3.1f')], ['slope, \sigma = ' num2str(100*Ld(end-1)^0.5,'%3.1f')],...
            ['curve \sigma = ' num2str(100*Ld(end-2)^0.5,'%3.1f')], [' \sigma = ' num2str(100*Ld(end-3)^0.5,'%3.1f')], [' \sigma = ' num2str(100*Ld(end-4)^0.5,'%3.1f')],4);
set(gca,'Xtick',1:maxmat); 
xlabel('Maturity, years')
ylabel('loading'); 

  
    print -depsc2 yield_factors_fed.eps


% part 1a: basic eigenvalue decomposition of forward rates for comparison

[Q,L] = eig(cov(f));
Ld = diag(L);
if ~min(Ld == sort(Ld));
    disp('**************ERROR eigenvalues are in wrong order'); 
end;
 

disp(' ');
fprintf(' f s.d of factors        %8.2f %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-4:end).^0.5);
fprintf('   percent of variance   %8.2f %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-4:end)/sum(Ld));

figure
plot(Q(:,end),'-vb','LineWidth',2);
hold on
plot(Q(:,end-1),'-or','LineWidth',2);
plot(Q(:,end-2),'-sg','LineWidth',2);
plot(Q(:,end-3),'--c');
plot(Q(:,end-4),'--m');
plot((1:maxmat)',0*(1:maxmat)','-k')
legend(['level, \sigma = ' num2str(100*Ld(end)^0.5,'%3.1f')], ['slope, \sigma = ' num2str(100*Ld(end-1)^0.5,'%3.1f')],...
            ['curve \sigma = ' num2str(100*Ld(end-2)^0.5,'%3.1f')], [' \sigma = ' num2str(100*Ld(end-3)^0.5,'%3.1f')], [' \sigma = ' num2str(100*Ld(end-4)^0.5,'%3.1f')],4);
set(gca,'Xtick',1:maxmat); 
xlabel('Maturity, years')
ylabel('loading'); 

    print -depsc2 forward_factors_fed.eps


% part 1c: basic eigenvalue decomposition of forward rate spreads for nolevel specification
fspread = f(:,2:end)-f(:,1)*ones(1,size(f,2)-1);
[Q,L] = eig(cov(fspread));
Ld = diag(L);
if ~min(Ld == sort(Ld));
    disp('**************ERROR eigenvalues are in wrong order'); 
end;

disp(' ');
disp('factors in forward rate spreads');
fprintf(' f s.d of factors        %8.2f %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-4:end).^0.5);
fprintf('   percent of variance   %8.2f %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-4:end)/sum(Ld));


figure
plot((2:size(Q,1)+1)',Q(:,end),'-vb','LineWidth',2);
hold on
plot((2:size(Q,1)+1)',Q(:,end-1),'-or','LineWidth',2);
plot((2:size(Q,1)+1)',Q(:,end-2),'-sg','LineWidth',2);
plot((2:size(Q,1)+1)',Q(:,end-3),'--c');
plot((2:size(Q,1)+1)',Q(:,end-4),'--m');
plot((2:maxmat)',0*(2:maxmat)','-k')
legend(['factor 1, \sigma = ' num2str(100*Ld(end)^0.5,'%3.1f')], ['factor 2, \sigma = ' num2str(100*Ld(end-1)^0.5,'%3.1f')],...
            ['factor 3 \sigma = ' num2str(100*Ld(end-2)^0.5,'%3.1f')], [' factor 4 \sigma = ' num2str(100*Ld(end-3)^0.5,'%3.1f')], [' \sigma = ' num2str(100*Ld(end-4)^0.5,'%3.1f')],4);
set(gca,'Xtick',1:maxmat); 
xlabel('Maturity, years')
ylabel('loading'); 
title('eigenvalue factors in forward spreads'); 


% now try forecasting trick to do level slope and curve with a random walk level factor

num_sprd_fctr = 2; % extra factors beyond random walk level factor
X = fspread*Q(:,end-num_sprd_fctr+1:end); % first three factors of the spreads
lhs = y(1+12:T,1)-y(1:T-12,1); 
rhs = [ones(T-12,1) X(1:T-12,:)]; 
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
a0 = b1(1); 
a = b1(2:end); % coefficients to forecast ch in 1 year rate from spread factors
disp('coefficients and R2 to forecast dy1 from spread factors')
disp([b1' R2]); 
disp('tstats')
disp([b1'./stb']); 

lhs = X(1+12:T,:); 
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
mutil = b1(1,:)';
phitil = b1(2:end,:)';
disp('eigenvalues of spread factor transition matrix -- need to be < 1'); 
disp(eig(phitil)'); 
alpha = inv(eye(num_sprd_fctr) -phitil')*a; 
muz = a0+alpha'*mutil; 
disp('alpha weights on spread factors to form random walk'); 
disp(alpha'); 
disp('muz random walk constant'); 
disp(100*muz); 
z =  y(:,1) + X*alpha; 
xloads = [zeros(1,num_sprd_fctr);Q(:,end-num_sprd_fctr+1:end)]...
        -ones(size(f,2),1)*alpha';

Etdy1 = [zeros(T,1) a0+X*a ];
EX = X; 
for i = 1:10; 
    EX = ones(T,1)*mutil' + EX*phitil'; 
    Etdy1 = [Etdy1 a0+EX*a];
end;
Ety1 = y(:,1)*ones(1,12) + cumsum( Etdy1')';

figure;
plot(Etdy1); 
figure;
plot(Ety1); 
hold on
plot(z)
        
  
       
figure; 
for i = 1:num_sprd_fctr; 
    factors_t = zeros(2,num_sprd_fctr); 
    y1_t = zeros(2,1); 
    factors_t(2,i) = 1;
    for t = 1:8;
        factors_t(t+2,:) = (phitil*factors_t(t+1,:)')'; 
        y1_t(t+2,1) = y1_t(t+2-1,1) + factors_t(t+1,:)*a;
    end;
    subplot(2,2,i); 
    plot((1:10)',y1_t,'-k','LineWidth',2)
    hold on
    plot((1:10)',factors_t(:,1),'-vr','LineWidth',2);
    hold on; 
    plot((1:10)',factors_t(:,2),'-ob','LineWidth',2);
    if num_sprd_fctr == 2; 
        legend('y1','f1','f2');
    end
    if num_sprd_fctr >= 3; 
        plot((1:10)',factors_t(:,3),'-sg','LineWidth',2);
        legend('y1','f1','f2','f3'); 
    end;
    if num_sprd_fctr == 4; 
        plot((1:10)',factors_t(:,4),'-^c','LineWidth',2);
        legend('y1','f1','f2','f3','f4'); 
    end;
    if i == 1; 
        title('Response to f1 shock'); 
    elseif i == 2; 
        title('Response to f2 shock'); 
    elseif i == 3; 
        title('Response to f3 shock'); 
    elseif i == 4; 
        title('Response to f4 shock'); 
    end; 
    
end;
        
    
 figure; 
 plot(plotdate,[y(:,1) z ]);
 hold on
 plot(plotdate,z);
         
 figure;
 plot([ones(size(xloads,1),1) xloads]); 
 title('loading of forward rates on random walk and spread factors') 

% -------------------------------------------
% part 2: eigenvalue decomposition of expected excess returns, return
% forecasting factor and its loadings on f
% -------------------------------------

%  -- eigenvalue decompose expected return matrix. 
   

      if nolev; 
        rhs = [ones(T-12*1,1) f_ma_fb(1:T-12*1,2:end)-f_ma_fb(1:T-12,1)*ones(1,4)]; % use spreads over 1 year rate  
        bigrhs = [ones(T,1) f_ma_fb(1:T,2:end)-f_ma_fb(1:T,1)*ones(1,4)];
      else;
        rhs = [ones(T-12*1,1) f_ma_fb(1:T-12*1,:)];   
        bigrhs = [ones(T,1) f_ma_fb(1:T,:)];
      end;

lhs = mean(rx(1*12+1:T,:)')';
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf('R2 from forecasting average returns across maturity \n'); 
fprintf( ' %8.2f ',R2);
fprintf('\n');


lhs = rx(1*12+1:T,:);
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf('R2 from forecasting returns \n'); 
fprintf( ' %8.0f ',1:size(R2,1));
fprintf('\n'); 
fprintf( ' %8.2f ',R2);
fprintf('\n');

Erx = bigrhs*b1; 
[Q,L] = eig(cov(Erx)); 
Ld = diag(L);
if ~min(Ld == sort(Ld));
    disp('**************ERROR eigenvalues are in wrong order'); 
end;


figure
plot((2:maxmat)',Q(:,end),'-vb','LineWidth',2);
hold on
plot((2:maxmat)',Q(:,end-1),'-or','LineWidth',2);
plot((2:maxmat)',Q(:,end-2),'-sg','LineWidth',2);
plot((2:maxmat)',Q(:,end-3),'--c','LineWidth',2);
plot((2:maxmat)',0*(2:maxmat)','-k','LineWidth',2)
legend(['Level, \sigma = ' num2str(100*Ld(end)^0.5,'%3.1f'), ', %\sigma^2 = ' num2str(100*Ld(end)/sum(Ld),'%3.1f')],...
       ['    2, \sigma = ' num2str(100*Ld(end-1)^0.5,'%3.1f'), ', %\sigma^2 = ' num2str(100*Ld(end-1)/sum(Ld),'%3.1f')],...
       ['    3, \sigma = ' num2str(100*Ld(end-2)^0.5,'%3.1f'), ', %\sigma^2 = ' num2str(100*Ld(end-2)/sum(Ld),'%3.1f')],...
       ['    4, \sigma = ' num2str(100*Ld(end-3)^0.5,'%3.1f'), ', %\sigma^2 = ' num2str(100*Ld(end-3)/sum(Ld),'%3.1f')],4);
set(gca,'Xtick',2:maxmat); 
xlabel('Maturity, years')
ylabel('loading'); 

  if nolev;
     print -depsc2 Erx_factors_nolev_fed.eps
  else;
    print -depsc2 Erx_factors_fed.eps
  end

fprintf(' ERx s.d of factors       %8.2f %8.2f %8.2f %8.2f  \n',100*Ld(end-3:end).^0.5);
fprintf('    percent of variance   %8.2f %8.2f %8.2f %8.2f \n',100*Ld(end-3:end)/sum(Ld));
    
if nolev
    gamma_nocon = ([-sum(b1(2:end,:)); b1(2:end,:)]*Q(:,end)); % express regression as coeffs on levels that add to 0
else
    gamma_nocon = (b1(2:end,:)*Q(:,end));
end;

figure; 
plot(gamma_nocon,'-v','LineWidth',2);
set(gca,'Xtick',(1:maxmat));
xlabel('Forward rate maturity')
ylabel('Loading')


  if nolev; 
    print -depsc2 gpf_eigenvalue_nolev_fed.eps
  else
    print -depsc2 gpf_eigenvalue_fed.eps
  end
%title('loadings on f to produce return forecast factor');
   

    gpfactor = f_ma_fb*gamma_nocon; 
    

% -------------------------------------
% part 3. Document that conventional factors do not span return-forecast
% factor
% -- modified for fed data; we can't do unconstrained return forecasting
% -------------------------------------

% 1: yield factors
[Q,L] = eig(cov(y));
Ld = diag(L);
if ~min(Ld == sort(Ld));
    disp('**************ERROR eigenvalues are in wrong order'); 
end;

level = y*Q(:,maxmat); 
slope = y*Q(:,maxmat-1); 
curve = y*Q(:,maxmat-2); 
f4 = y*Q(:,maxmat-3);
f5 = y*Q(:,maxmat-4);

rhs = [ones(T,1) level ];
[b1,stb,R2,R2adj,v,F] = olsgmm(gpfactor,rhs,12,0);
fprintf('regressions of return-forecast factor on yield curve factors\n'); 
fprintf('                    %8s %8s %8s %8s %8s \n','const','level','slope','curve','R2'); 
fprintf('yield factors       %8.2f %8.2f %8s %8s %8.2f \n', b1,' ', ' ', R2); 

rhs = [ones(T,1) level slope];
[b1,stb,R2,R2adj,v,F] = olsgmm(gpfactor,rhs,12,0);
fprintf('yield factors       %8.2f %8.2f %8.2f %8s %8.2f \n', b1, ' ', R2); 
rhs = [ones(T,1) level slope curve];
[b1,stb,R2,R2adj,v,F] = olsgmm(gpfactor,rhs,12,0);
fprintf('yield factors       %8.2f %8.2f %8.2f %8.2f %8.2f \n', b1, R2); 

% 2: forward factors
[Qf,Lf] = eig(cov(f));
Ldf = diag(Lf);
if ~min(Ldf == sort(Ldf));
    disp('**************ERROR eigenvalues are in wrong order'); 
end;

levelf = f*Qf(:,maxmat); 
slopef = f*Qf(:,maxmat-1); 
curvef = f*Qf(:,maxmat-2); 
f4f = f*Qf(:,maxmat-3); 
f5f = f*Qf(:,maxmat-4); 


rhs = [ones(T,1) levelf ];
[b1,stb,R2,R2adj,v,F] = olsgmm(gpfactor,rhs,12,0);
fprintf('fwd factors        %8.2f %8.2f %8s %8s %8.2f \n', b1, ' ',' ', R2); 
rhs = [ones(T,1) levelf slopef];
[b1,stb,R2,R2adj,v,F] = olsgmm(gpfactor,rhs,12,0);
fprintf('fwd factors        %8.2f %8.2f %8.2f %8s %8.2f \n', b1, ' ', R2); 
rhs = [ones(T,1) levelf slopef curvef];
[b1,stb,R2,R2adj,v,F] = olsgmm(gpfactor,rhs,12,0);
fprintf('fwd factors        %8.2f %8.2f %8.2f %8.2f %8.2f \n', b1, R2); 

% forecasting returns with return-forecast vs. other factors

lhs = mean(rx(1+12:T,:)')'; 
rhs = [ones(T-12,1) gpfactor(1:T-12)];
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);

disp(''); 
fprintf('forecasting average (across maturity) returns with factors\n'); 
fprintf('                       %6s  %6s  %6s  %6s  %6s  %6s  %6s  %6s \n', 'const', 'rfactor' ,'level' ,'slope', 'curve', 'f4', 'f5','R2')
fprintf('  return-forecast fctr %6.2f  %6.2f  %6s  %6s  %6s %6s  %6s %6.2f \n',b1,' ',' ',' ',' ',' ',R2); 
fprintf('  t stat              (%6.2f)(%6.2f) %6s  %6s  %6s %6s  %6s %6.2f \n',b1./stb,' ',' ',' ',' ',' ',R2); 

fprintf(' fraction of yield var %6s  %6s  %6.2f %6.2f %6.2f  %6.2f %6.2f\n',' ',' ', 100*Ld(end:-1:end-4)/sum(Ld));

rhs = [ones(T-12,1) level(1:T-12)]; % level alone
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' yields                %6.2f  %6s  %6.2f  %6s  %6s %6s  %6s %6.2f\n',b1(1),' ',b1(2),' ',' ',' ',' ',R2); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) %6s  %6s %6s  %6s %6.2f\n',b1(1)/stb(1),' ',b1(2)/stb(2),' ',' ',' ',' ',R2); 
b1a = b1; 

rhs = [ones(T-12,1) level(1:T-12) slope(1:T-12)]; % level and slope
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' yields                %6.2f  %6s  %6.2f  %6.2f  %6s %6s %6s  %6.2f\n',b1(1),' ',b1(2:3),' ',' ',' ',R2);
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) %6s  %6s %6s %6.2f\n',b1(1)/stb(1),' ',b1(2:3)./stb(2:3),' ',' ',' ',R2);
b1b = b1; 

rhs = [ones(T-12,1) level(1:T-12) slope(1:T-12) curve(1:T-12)];  % level slope and curve
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' yields                %6.2f  %6s  %6.2f   %6.2f   %6.2f %6s  %6s %6.2f\n',b1(1),' ',b1(2:4),' ',' ',R2); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) (%6.2f) %6s %6s %6.2f\n',b1(1),' ',b1(2:4)./stb(2:4),' ',' ',R2); 
b1c = b1; 

rhs = [ones(T-12,1) level(1:T-12) slope(1:T-12) curve(1:T-12) f4(1:T-12)];  % level slope curve and f4
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' yields                %6.2f  %6s  %6.2f   %6.2f   %6.2f  %6.2f %6s %6.2f\n',b1(1),' ',b1(2:5),' ',R2); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) (%6.2f) (%6.2f) %6s %6.2f\n',b1(1),' ',b1(2:5)./stb(2:5),' ', R2); 
b1d = b1;

rhs = [ones(T-12,1) level(1:T-12) slope(1:T-12) curve(1:T-12) f4(1:T-12) f5(1:T-12)];  % level slope curve and f4
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' yields                %6.2f  %6s  %6.2f   %6.2f   %6.2f  %6.2f %6.2f %6.2f\n',b1(1),' ',b1(2:6),R2); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) (%6.2f) (%6.2f) (%6.2f) %6.2f\n',b1(1),' ',b1(2:6)./stb(2:6), R2); 
b1e = b1;

% picture of regression coefficients from yield factors
% if rx = a + b*level + c*slope and level = Q(:,5)'f etc. then
% rx = a+b*Q(:,5)+c*Q(:,4)
figure
plot((1:maxmat)',b1a(1)+b1a(2)*Q(:,maxmat),'-vc','LineWidth',2)
hold on
plot((1:maxmat)',b1b(1)+b1b(2)*Q(:,maxmat)+b1b(3)*Q(:,maxmat-1),'-og','LineWidth',2)
plot((1:maxmat)',b1c(1)+b1c(2)*Q(:,maxmat)+b1c(3)*Q(:,maxmat-1)+b1c(4)*Q(:,maxmat-2),'-sb','LineWidth',2)
    plot((1:maxmat)',b1d(1)+b1d(2)*Q(:,maxmat)+b1d(3)*Q(:,maxmat-1)+b1d(4)*Q(:,maxmat-2)+b1d(5)*Q(:,maxmat-3),'-^r','LineWidth',2)
    plot((1:maxmat)',b1e(1)+b1e(2)*Q(:,maxmat)+b1e(3)*Q(:,maxmat-1)+b1e(4)*Q(:,maxmat-2)+b1e(5)*Q(:,maxmat-3)+b1e(6)*Q(:,maxmat-4),'-*m','LineWidth',2)
    legend('level','level, slope','level, slope, curve','l,s,c,f4','l,s,c,f4,f5','Location','South');
set(gca,'Xtick',(1:maxmat));
xlabel('yield maturity')
ylabel('regression coefficients')
title('regression coeffs from yield factors') 

% implied coefficients on forwards from coefficients on yields. 
% a + b1 y(1) + b2 y(2) + b3 y(3) = a + b1(-p(1)) + b2(-p2/2) + b3 (-p3/3) + ...
% = a + b1( f(1))  + b2  ( y(1) + f(2) ) 2/  + b3 ( y(1) + f(2) + f(3) ) / 3 + ...
% = a + (b1+b2/2+b3/3+...) f(1)  + (b2/2 +b3/3+..) f(2)  + (b3/3+b4/4+..) f(4)...

figure
plot((1:maxmat)',b1a(1)+b1a(2)*Q(:,maxmat),'-vc','LineWidth',2)
hold on
plot((1:maxmat)',b1b(1)+sum(b1b(2:3)./(1:2)')*Q(:,maxmat)+b1b(3)/2*Q(:,maxmat-1),'-og','LineWidth',2)
plot((1:maxmat)',b1c(1)+sum(b1c(2:4)./(1:3)')*Q(:,maxmat)+sum(b1c(3:4)./(2:3)')*Q(:,maxmat-1)+b1c(4)/3*Q(:,maxmat-2),'-sb','LineWidth',2)
    plot((1:maxmat)',b1d(1)+sum(b1d(2:5)./(1:4)')*Q(:,maxmat)+sum(b1d(3:5)./(2:4)')*Q(:,maxmat-1)+sum(b1d(4:5)./(3:4)')*Q(:,maxmat-2)+b1d(5)/4*Q(:,maxmat-3),'-^r','LineWidth',2)
    plot((1:maxmat)',b1e(1)+sum(b1e(2:6)./(1:5)')*Q(:,maxmat)+sum(b1e(3:6)./(2:5)')*Q(:,maxmat-1)+...
            sum(b1e(4:6)./(3:5)')*Q(:,maxmat-2)+sum(b1e(5:6)./(4:5)')*Q(:,maxmat-3)+b1e(6)/6*Q(:,maxmat-4),'-*m','LineWidth',2)
    legend('level','level, slope','level, slope, curve','l,s,c,f4','l,s,c,f4,f5','Location','South');
            plot((1:5)',gamma_nocon,'-dr','LineWidth',2)
            legend('level','level, slope','level, slope, curve','l,s,c,f4','l,s,c,f4,f5','gamma','Location','South');
set(gca,'Xtick',(1:maxmat));
xlabel('forward maturity')
ylabel('regression coefficients')
title('implied forward coeffs from yield factors') 


% -----------------------------
% Same thing with forward rates -- compare return forecasts of gpf and
% forward factors. This one is used in paper
% ----------------------------

disp('') 

fprintf(' fraction of fwd var   %6s %6s %6.2f %6.2f %6.2f  %6.2f %6.2f\n',' ',' ', 100*Ldf(end:-1:end-4)/sum(Ldf));

rhs = [ones(T-12,1) levelf(1:T-12)]; % level alone
[b1a,stb,R2a,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' forwards              %6.2f  %6s  %6.2f  %6s  %6s %6s  %6s %6.2f\n',b1a(1),' ',b1a(2),' ',' ',' ',' ',R2a); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) %6s  %6s %6s  %6s %6.2f\n',b1a(1)/stb(1),' ',b1a(2)/stb(2),' ',' ',' ',' ',R2a); 


rhs = [ones(T-12,1) levelf(1:T-12) slopef(1:T-12)];
[b1b,stb,R2b,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' forwards              %6.2f  %6s  %6.2f   %6.2f  %6s %6s %6s %6.2f\n',b1b(1),' ',b1b(2:3),' ',' ',' ',R2b);
fprintf(' t stat               (%6.2f) %6s (%6.2f) (%6.2f) %6s %6s %6s %6.2f\n',b1b(1)/stb(1),' ',b1b(2:3)./stb(2:3),' ',' ',' ',R2b);

rhs = [ones(T-12,1) levelf(1:T-12) slopef(1:T-12) curvef(1:T-12)];
[b1c,stb,R2c,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' forwards              %6.2f  %6s  %6.2f   %6.2f   %6.2f %6s %6s %6.2f\n',b1c(1),' ',b1c(2:4),' ',' ',R2c); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) (%6.2f) %6s %6s %6.2f\n',b1c(1)/stb(1),' ',b1c(2:4)./stb(2:4),' ',' ',R2c); 

rhs = [ones(T-12,1) levelf(1:T-12) slopef(1:T-12) curvef(1:T-12) f4f(1:T-12)];
[b1d,stb,R2d,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' forwards              %6.2f  %6s  %6.2f   %6.2f   %6.2f %6.2f %6s %6.2f\n',b1d(1),' ',b1d(2:5),' ',R2d); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) (%6.2f) (%6.2f) %6s %6.2f\n',b1d(1)/stb(1),' ',b1d(2:5)./stb(2:5),' ',R2d); 

rhs = [ones(T-12,1) levelf(1:T-12) slopef(1:T-12) curvef(1:T-12) f4f(1:T-12) f5f(1:T-12)];
[b1e,stb,R2e,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf(' forwards              %6.2f  %6s  %6.2f   %6.2f   %6.2f %6.2f %6.2f %6.2f\n',b1e(1),' ',b1e(2:6),R2e); 
fprintf(' t-stat               (%6.2f) %6s (%6.2f) (%6.2f) (%6.2f) (%6.2f) (%6.2f) %6.2f\n',b1e(1)/stb(1),' ',b1e(2:6)./stb(2:6),R2e); 

% picture of implied regression coefficients on forward rates
% if rx = a + b*level + c*slope and level = Q(:,5)'f etc. then
% rx = a+b*Q(:,5)+c*Q(:,4)
figure
plot((1:maxmat)',b1a(1)+b1a(2)*Qf(:,maxmat),'-vc','LineWidth',2)
hold on
plot((1:maxmat)',b1b(1)+b1b(2)*Qf(:,maxmat)+b1b(3)*Qf(:,maxmat-1),'-og','LineWidth',2)
plot((1:maxmat)',b1c(1)+b1c(2)*Qf(:,maxmat)+b1c(3)*Qf(:,maxmat-1)+b1c(4)*Qf(:,maxmat-2),'-sb','LineWidth',2)

    plot((1:maxmat)',b1d(1)+b1d(2)*Qf(:,maxmat)+b1d(3)*Qf(:,maxmat-1)+b1d(4)*Qf(:,maxmat-2)+b1d(5)*Qf(:,maxmat-3),'-^r','LineWidth',2)
    plot((1:maxmat)',b1e(1)+b1e(2)*Qf(:,maxmat)+b1e(3)*Qf(:,maxmat-1)+b1e(4)*Qf(:,maxmat-2)+b1e(5)*Qf(:,maxmat-3)+b1e(6)*Qf(:,maxmat-4),'-*m','LineWidth',2)
    legend('level','level, slope','level, slope, curve','l,s,c,f4','l,s,c,f4,f5','Location','South');
        plot((1:5)',gamma_nocon,'-dr','LineWidth',2)
        legend('level','level, slope','level, slope, curve','l,s,c,f4','l,s,c,f4,f5','\gamma''f','Location','South');
set(gca,'Xtick',(1:maxmat));
xlabel('forward maturity')
ylabel('regression coefficients')


  if nolev; 
    print -depsc2 factor_forecast_coeffs_nolev_fed.eps
  else;
    %axis([1 5 -5 7]); 
    print -depsc2 factor_forecast_coeffs_fed.eps
  end;

% -------------
% Now, can we forecast gpf with just the factors or do we need a new gpf
% factor too? 
% -----------------


lhs = gpfactor(1+12:T);
rhs = [ones(T-12,1) gpfactor(1:T-12) levelf(1:T-12) slopef(1:T-12) curvef(1:T-12)]; 
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp(' ');
disp('Forecasting gpf -- are factors enough or do we need a new gpf forecasting factor?') 
fprintf('    %10s %10s %10s %10s %10s %10s %10s \n','x','level','slope','curve','f4f','f5f','R2')
fprintf('b   %10.3f %10.3f %10.3f %10.3f %10s %10s %10.3f \n', b1(2:end),' ',' ', R2);
fprintf('t   %10.3f %10.3f %10.3f %10.3f  \n', b1(2:end)./stb(2:end));

rhs = [ones(T-12,1) gpfactor(1:T-12) levelf(1:T-12) slopef(1:T-12) curvef(1:T-12) f4f(1:T-12) f5f(1:T-12)]; 
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf('b   %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f \n', b1(2:end), R2);
fprintf('t   %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f \n', b1(2:end)./stb(2:end));


rhs = [ones(T-12,1) f_ma_fb(1:T-12,:)];
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('forecast using all fb MA forwards')
fprintf('    %10s %10s %10s %10s %10s %10s \n','y1','f2','f3','f4','f5','R2')
fprintf('b   %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f \n', b1(2:end), R2);
fprintf('t   %10.3f %10.3f %10.3f %10.3f %10.3f \n', b1(2:end)./stb(2:end));

rhs = [ones(T-12,1) f_ma_fb(1:T-12,[1 3 5])];
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
disp('forecast using 3 fb MA forwards')
fprintf('    %10s %10s %10s %10s \n','y1','f3','f5','R2')
fprintf('b   %10.3f %10.3f %10.3f %10.3f \n', b1(2:end), R2);
fprintf('t   %10.3f %10.3f %10.3f  \n', b1(2:end)./stb(2:end));

disp('forecast using x level slope curve and 3 fb forwards')
rhs = [ones(T-12,1) gpfactor(1:T-12) levelf(1:T-12) slopef(1:T-12) curvef(1:T-12) f_ma_fb(1:T-12,[1 3 5])]; 
[b1,stb,R2,R2adj,v,F] = olsgmm(lhs,rhs,12,0);
fprintf('    %10s %10s %10s %10s %10s %10s %10s %10s \n','x','level','slope','curve','y1','f3','f5','R2')
fprintf('b   %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f \n', b1(2:end), R2);
fprintf('t   %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f %10.3f \n', b1(2:end)./stb(2:end));


