% follow on to fed_yc_regressions. 
% does calculations and plot for duffee comments

close all
disp('lambda0l and lambda1l ' );
disp([lam0a lam1a]);
disp('10,000*vll'); 
disp(10000*V(2,2));
disp('std(x)');
disp(std(x));

sigtm = abs( (lam0a+lam1a*x)*V(2,2)^0.5);
esigt = mean(sigtm.^2)^0.5;
figure
plot(plotdate,sigtm)
hold on
plot(plotdate,0*sigtm+esigt,'-r','linewidth',2);
legend('\sigma_t(m_{t+1})','E(\sigma_t(m_{t+1}))');
title('Discount factors in Cochrane-Piazzesi 2008');
print -depsc2 sig2m_duffee.eps; 

sigtm = abs( (lam0a/2+lam1a/2*x)*V(2,2)^0.5);
esigt2 = mean(sigtm.^2).^0.5;
figure
plot(plotdate,sigtm)
hold on
plot(plotdate,0*sigtm+esigt2,'-r','linewidth',2);
legend('\sigma_t(m_{t+1})','E(\sigma_t(m_{t+1}))');
title('Discount factors in Cochrane-Piazzesi 2008 1/2 \lambda model');
print -depsc2 sig2m_halflambda_duffee.eps;

disp('mean sigma; full and half models');
disp([esigt esigt2]); 

% forward rate plot
datep = 350; 
figure
subplot(2,2,1);
plot((1:15)',100*f(datep,:),'-o'); 
hold on
plot((1:5)',100*f_fb(datep,:),'-r','linewidth',2);
legend('GSW','FB')
title(['GSW and FB data on ' num2str(plotdate(datep),'%4.2f')])

subplot(2,2,2);
plot((1:15)',100*f(datep+6,:),'-o'); 
hold on
plot((1:5)',100*f_fb(datep+6,:),'-r','linewidth',2);
legend('GSW','FB')
title(['GSW and FB data on ' num2str(plotdate(datep+6),'%4.2f')])

subplot(2,2,3);
plot((1:15)',100*f(datep+12,:),'-o'); 
hold on
plot((1:5)',100*f_fb(datep+12,:),'-r','linewidth',2);
legend('GSW','FB')
title(['GSW and FB data on ' num2str(plotdate(datep+12),'%4.2f')])


subplot(2,2,4);
plot((1:15)',100*f(datep+18,:),'-o'); 
hold on
plot((1:5)',100*f_fb(datep+18,:),'-r','linewidth',2);
legend('GSW','FB')
title(['GSW and FB data on ' num2str(plotdate(datep+18),'%4.2f')])
print -depsc2 duffee_GSB_FB.eps

% -----------------------
% mean-variance analysis
% -------------------------

rgsw = r(fd15:end,1:14); 
rduffee= [r_fb(13:end,:) rgsw(15:end,[6 10]')];
Ed = mean(rduffee)'; 
covd = cov(rduffee);
disp('individual sharpes')
disp(Ed'./diag(covd)'.^0.5); 
disp('max sharpe'); 
disp((Ed'*inv(covd)*Ed)^0.5)