% plot_r plots impulse response functions
% phi is the transition matrix. Label is a single text string to identify
% which phi this is, appears on graph
function plot_ir(phi,label)
num_factors = size(phi,1);
figure; 
for i = 1:num_factors; 
    factors_t = zeros(2,num_factors); 
    factors_t(2,i) = 1;
    for t = 1:9;
        factors_t(t+2,:) = (phi*factors_t(t+1,:)')'; 
    end;
    factors_t(:,1) = factors_t(:,1)/2; % divide by 2 so it shows better on the graph
    subplot(2,2,i); 
    plot((0:10)',factors_t(:,1),'-vr','LineWidth',2); 
    hold on;
    plot((0:10)',factors_t(:,2),'--ob','LineWidth',2);
    plot((0:10)',factors_t(:,3),'-sg','LineWidth',2);
    if num_factors == 3; 
        if (i == 1) | (i == 2); 
            legend('x','level','slope'); 
        end; 
        if i == 3; 
            legend('x','level','slope',4); 
        end;
    end;
    if num_factors == 4; 
        plot((0:10)',factors_t(:,4),'--^c','LineWidth',2);
        if (i == 1) ; 
            legend('x','level','slope','curve'); 
        end; 
    end;
    if i == 1; 
        title(['Resp. to x shock -- ' label]); 
    elseif i == 2; 
        title('Resp. to level shock'); 
    elseif i == 3; 
        title('Resp. to slope shock'); 
    elseif i == 4; 
        title('Resp. to curve shock'); 
    end; 
    xlabel('Years'); 
    ylabel('Percent'); 
    
end;
