%affine calcualtions. 
% does affine model calculation for fed_yc_regressions and minobj
% forwards f_t = Af + Bf*X_t

function [A,B,Af,Bf] = affine_calculations(delta0,delta1,phistar,mustar,V,maxcalc);

num_factors = size(mustar,1); 
if ~(size(delta1) == num_factors)
    disp('Affine calculations error -- inputs are the wrong size'); 
end
A = zeros(maxcalc,1);  % p(n)_t = A(n) + B(n,:)*X_t. B(n,:) is B_n' in paper notation
B = zeros(maxcalc,num_factors); 
B(1,:) = -delta1' ;
A(1) = -delta0 ;
for i = 2:maxcalc;
    B(i,:) = -delta1' + B(i-1,:)*phistar;
    A(i) = -delta0 + A(i-1) + B(i-1,:)*mustar + 1/2*B(i-1,:)*V*B(i-1,:)';
end; 
Af = zeros(maxcalc,1); 
Bf = zeros(maxcalc,num_factors); 
Af(1) = delta0; 
Bf(1,:) = delta1'; % first forward is one year yield
Af(2:maxcalc) = A(1:maxcalc-1)-A(2:maxcalc); 
Bf(2:maxcalc,:) = B(1:maxcalc-1,:)-B(2:maxcalc,:); 
