% plot_r_eyandf plots impulse response functions for Ey, forward rates, etc.  
% phi is the transition matrix. Label is a single text string to identify
% which phi this is, appears on graph
function plot_ir(phi,delta1,Bf,label)
num_factors = size(phi,1);
figure; 
for i = 1:num_factors; 
    factors_t = zeros(2,num_factors); 
    fwds_t = zeros(2,1); 
    factors_t(2,i) = 1;
    fwds_t(2,1)=factors_t(2,:)*Bf(1,:)';
    for t = 1:9;
        factors_t(t+2,:) = (phi*factors_t(t+1,:)')'; 
        fwds_t(t+2,1) = factors_t(2,:)*Bf(t+1,:)';
    end;
    Ey1 = factors_t*delta1;
    
    subplot(2,2,i); 
    plot((0:10)',fwds_t,'-vr','linewidth',2);
    hold on;
    plot((0:10)',Ey1,'--k','linewidth',2);
    plot((0:10)',factors_t(:,1)/3,'-sb','linewidth',2);
    plot((0:10)',0*(0:10)','-k');
    
    %plot((1:10)',factors_t(:,1),'-vr','LineWidth',2); 
    if i == 1; 
        title(['Resp. to x shock -- ' label]); 
        legend('Current forwards','Expected yield','Er factor x',1); 
    elseif i == 2; 
        title('Resp. to level shock'); 
    elseif i == 3; 
        title('Resp. to slope shock'); 
    elseif i == 4; 
        title('Resp. to curve shock'); 
    end; 
    xlabel('Time and maturity, years'); 
    ylabel('Percent')
end;
